local L = AceLibrary("AceLocale-2.2"):new("KingOfTheJungle")
local PT = AceLibrary:GetInstance("PeriodicTable-3.0")
local BS = AceLibrary:GetInstance("Babble-Spell-2.2")
local PL = ParserLib:GetInstance("1.1")

local KOTJDBVERSION = 8

KingOfTheJungle = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDB-2.0", "AceEvent-2.0")

KingOfTheJungle:RegisterDB("KingOfTheJungleDB", "KingOfTheJungleDBPerChar")

KingOfTheJungle:RegisterDefaults('char', {
	warnPetHungry = true,
	petHappinessLevel = 2,
    msgInterval = 60,
	lastWarningTime = 0,
	buttonX = 100,
	buttonY = 0,
	buttonScale = 1.2,
	buttonPoint = "CENTER",
	showUnknownFood = true,
})

KingOfTheJungle:RegisterDefaults('profile', {
	version = nil,
	foodlist = nil
})

function KingOfTheJungle:InitDB()	
	local convert = function(t_old)
		if t_old then
			local t = {}			
			for k, v in pairs(t_old) do
				local f = {}
				f["id"] = tonumber(k)
				if tonumber(v) then
					f["value"] = tonumber(v)
				else
					f["value"] = 0
				end
				f["selected"] = true
				
				table.insert(t,f)
			end
			
			table.sort(t, function (a,b) return a.value > b.value end)
			
			return t
		end
		
		return nil
	end
	
	if self.db.profile.foodlist == nil then
		self.db.profile.foodlist = {}
		
		table.insert(self.db.profile.foodlist,{
			["diet"] = "Food - Meat Raw", 
			["list"] = convert(PT:GetSetTable("Consumable.Food.Inedible.Meat")),
			["icon"] = "Interface\\Icons\\INV_Misc_Food_71",
			["selected"] = false,
		})
		table.insert(self.db.profile.foodlist,{
			["diet"] = "Food - Meat Basic", 
			["list"] = convert(PT:GetSetTable("Consumable.Food.Edible.Meat.Basic")),
			["icon"] = "Interface\\Icons\\INV_Misc_Food_15",
			["selected"] = true,
		})
		table.insert(self.db.profile.foodlist,{
			["diet"] = "Food - Meat Bonus", 
			["list"] = convert(PT:GetSetTable("Consumable.Food.Edible.Meat.Bonus")),
			["icon"] = "Interface\\Icons\\INV_Misc_Food_48",
			["selected"] = false,
		})
--~ 		table.insert(self.db.profile.foodlist,{
--~ 			["diet"] = "Food - Meat Stats", 
--~ 			["list"] = convert(PT:GetSetTable("Food - Meat Stats")),
--~ 			["icon"] = "Interface\\Icons\\INV_Drink_17",
--~ 			["selected"] = false,
--~ 		})
		table.insert(self.db.profile.foodlist,{
			["diet"] = "Food - Bread Basic", 
			["list"] = convert(PT:GetSetTable("Consumable.Food.Edible.Bread.Basic")),
			["icon"] = "Interface\\Icons\\INV_Misc_Food_12",
			["selected"] = true,
		})
		table.insert(self.db.profile.foodlist,{
			["diet"] = "Food - Bread Bonus", 
			["list"] = convert(PT:GetSetTable("Consumable.Food.Edible.Bread.Bonus")),
			["icon"] = "Interface\\Icons\\INV_Misc_Food_62",
			["selected"] = false,
		})
		table.insert(self.db.profile.foodlist,{
			["diet"] = "Food - Bread Combo", 
			["list"] = convert(PT:GetSetTable("Consumable.Food.Edible.Bread.Combo")),
			["icon"] = "Interface\\Icons\\INV_Misc_QuestionMark",
			["selected"] = false,
		})
		table.insert(self.db.profile.foodlist,{
			["diet"] = "Food - Bread Conjured", 
			["list"] = convert(PT:GetSetTable("Consumable.Food.Edible.Bread.Conjured")),
			["icon"] = "Interface\\Icons\\INV_Misc_Food_73CinnamonRoll",
			["selected"] = true,
		})
		table.insert(self.db.profile.foodlist,{
			["diet"] = "Food - Cheese Basic", 
			["list"] = convert(PT:GetSetTable("Consumable.Food.Edible.Cheese.Basic")),
			["icon"] = "Interface\\Icons\\INV_Misc_Food_37",
			["selected"] = true,
		})
		table.insert(self.db.profile.foodlist,{
			["diet"] = "Food - Cheese Bonus", 
			["list"] = convert(PT:GetSetTable("Consumable.Food.Edible.Cheese.Bonus")),
			["icon"] = "Interface\\Icons\\INV_Misc_Food_06",
			["selected"] = false,
		})
		table.insert(self.db.profile.foodlist,{
			["diet"] = "Food - Fish Raw", 
			["list"] = convert(PT:GetSetTable("Consumable.Food.Inedible.Fish")),
			["icon"] = "Interface\\Icons\\INV_Misc_Fish_06",
			["selected"] = false,
		})
		table.insert(self.db.profile.foodlist,{
			["diet"] = "Food - Fish Basic", 
			["list"] = convert(PT:GetSetTable("Consumable.Food.Edible.Fish.Basic")),
			["icon"] = "Interface\\Icons\\INV_Misc_Fish_07",
			["selected"] = true,
		})
		table.insert(self.db.profile.foodlist,{
			["diet"] = "Food - Fish Bonus", 
			["list"] = convert(PT:GetSetTable("Consumable.Food.Edible.Fish.Bonus")),
			["icon"] = "Interface\\Icons\\INV_Misc_Fish_05",
			["selected"] = false,
		})
		table.insert(self.db.profile.foodlist,{
			["diet"] = "Food - Fish Combo", 
			["list"] = convert(PT:GetSetTable("Consumable.Food.Edible.Fish.Combo")),
			["icon"] = "Interface\\Icons\\INV_Misc_Fish_13",
			["selected"] = false,
		})
		table.insert(self.db.profile.foodlist,{
			["diet"] = "Food - Fruit Basic", 
			["list"] = convert(PT:GetSetTable("Consumable.Food.Edible.Fruit.Basic")),
			["icon"] = "Interface\\Icons\\INV_Misc_Food_20",
			["selected"] = true,
		})
		table.insert(self.db.profile.foodlist,{
			["diet"] = "Food - Fruit Bonus", 
			["list"] = convert(PT:GetSetTable("Consumable.Food.Edible.Fruit.Bonus")),
			["icon"] = "Interface\\Icons\\INV_Misc_Food_58",
			["selected"] = false,
		})
		table.insert(self.db.profile.foodlist,{
			["diet"] = "Food - Fruit Combo", 
			["list"] = convert(PT:GetSetTable("Consumable.Food.Edible.Fruit.Combo")),
			["icon"] = "Interface\\Icons\\INV_Misc_QuestionMark",
			["selected"] = false,
		})
		table.insert(self.db.profile.foodlist,{
			["diet"] = "Food - Fungus Basic", 
			["list"] = convert(PT:GetSetTable("Consumable.Food.Edible.Fungus.Basic")),
			["icon"] = "Interface\\Icons\\INV_Mushroom_11",
			["selected"] = true,
		})
		table.insert(self.db.profile.foodlist,{
			["diet"] = "Food - Fungus Bonus", 
			["list"] = convert(PT:GetSetTable("Consumable.Food.Edible.Fungus.Bonus")),
			["icon"] = "Interface\\Icons\\INV_Misc_QuestionMark",
			["selected"] = false,
		})
		table.insert(self.db.profile.foodlist,{
			["diet"] = "Food - Fungus Combo", 
			["list"] = convert(PT:GetSetTable("Consumable.Food.Edible.Fungus.Combo")),
			["icon"] = "Interface\\Icons\\INV_Misc_QuestionMark",
			["selected"] = false,
		})
	end
end

function KingOfTheJungle:tablecopy(t)
	if not t then
		return t
	end
	
	local tmp = {}
	for i,v in pairs(t) do
		if type(v) == table then
			tmp[i] = self:tablecopy(v)
		else
			tmp[i] = v
		end		
	end
	return tmp
end

function KingOfTheJungle:tableswap(t1,t2)
	local tmp = self:tablecopy(t1)
	t1 = self:tablecopy(t2)
	t2 = self:tablecopy(tmp)
	return t1, t2
end

function KingOfTheJungle:OverrideBindings()
	local key1, key2 = GetBindingKey("KOTJFeedButton")
	if key1 then
		SetOverrideBindingClick(self.feedButton, false, key1, "KOTJFeedButton") 
--~ 		SetBindingClick(key1,"KOTJFeedButton")
	end
	if key2 then
		SetOverrideBindingClick(self.feedButton, false, key2, "KOTJFeedButton") 
--~ 		SetBindingClick(key2,"KOTJFeedButton")		
	end
end

function KingOfTheJungle:OnInitialize()	
	BINDING_HEADER_KingOfTheJungle = L["King of the Jungle"]	
	BINDING_NAME_KOTJFeedButton = BS["Feed Pet"]

	local options = { 
		type = "group",
			args = {				
				menu = {
					name = L["Show Config"], desc = L["Shows Config Screen"], type = 'execute',
					func = function() self:KOTJUI_Show() end
				},
				resetdb = {
					name = L["Reset Food"], desc = L["Reset Food Database"], type = 'execute',
					func = function() 
						self.db.profile.foodlist = nil  
						self.db.profile.version = KOTJDBVERSION  
						self:InitDB()
					end
				}
			}
		}

	KingOfTheJungle:RegisterChatCommand({"/kotj"}, options)
	
	if not self.db.profile.version or (self.db.profile.version < KOTJDBVERSION) then
		self:Print("Upgrading Food Database.")
		self.db.profile.foodlist = nil  
		self.db.profile.version = KOTJDBVERSION
	end
	
	self:InitDB()
	
	self:Print("Rawrrrrrr...")
end

function KingOfTheJungle:OnEnable()	
	self.feedButton = CreateFrame("Button", "KOTJFeedButton", UIParent, "SecureActionButtonTemplate,ActionButtonTemplate")					
	self.feedButton:SetPoint(self.db.char.buttonPoint,self.db.char.buttonX,self.db.char.buttonY) 	
	KOTJFeedButtonIcon:SetTexture("Interface\\Icons\\Ability_Hunter_BeastTraining")
	self.feedButton:Hide()
	self.feedButton:SetMovable(1)
	self.feedButton:RegisterForDrag("LeftButton")
	self.feedButton:SetScale(self.db.char.buttonScale)
	
	self.feedButton:SetAttribute("unit", "player")
	self.feedButton:SetAttribute("type", "spell")
	self.feedButton:SetAttribute("spell", BS["Feed Pet"])
	self.feedButton:SetAttribute("target-item", ATTRIBUTE_NOOP)
			
	self.feedButton:SetScript("OnEnter", function()
		local itemlink = self:FeedPet()
		if ( itemlink ) then
			GameTooltip:SetOwner(this,"ANCHOR_RIGHT")
			GameTooltip:SetHyperlink(itemlink)
			GameTooltip:Show()
		else
			GameTooltip:SetOwner(this,"ANCHOR_RIGHT")
			GameTooltip:SetText(L["No food available for your pet."], 1.0,1.0,1.0)
			GameTooltip:Show()
		end			
	end)
	
	self.feedButton:SetScript("OnLeave", function()
		GameTooltip:Hide()		
	end)
	
--~ 	Make a more smoother fix for this
	self.feedButton:SetScript("PreClick", function()
		local itemlink = self:FeedPet()
		if not itemlink then									
			if UnitName("pet") then
				KingOfTheJungle:Chat(string.format(L["%s looks in your bags and sees no food in there."],UnitName("pet")))
			end
		end
	end)
	
	self.feedButton:SetScript("PostClick", function()
		self:HideFeedPetButton()	
	end)	
	
	self.feedButton:SetScript("OnDragStart", function()
		this:StartMoving()
	end)
	
	self.feedButton:SetScript("OnDragStop", function()
		this:StopMovingOrSizing()
		ValidateFramePosition(this)
		self.db.char.buttonPoint,_,_,self.db.char.buttonX,self.db.char.buttonY = this:GetPoint()
	end)
		
	_, englishClass = UnitClass("player")
	
	self:RegisterEvent("UPDATE_BINDINGS")
	
	if englishClass == "HUNTER" then				
		self:RegisterEvent("UNIT_HAPPINESS") 
		self:RegisterEvent("CHAT_MSG_SPELL_FAILED_LOCALPLAYER")	

		self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
		self:RegisterEvent("PLAYER_CONTROL_LOST")
		self:RegisterEvent("PLAYER_REGEN_DISABLED")			
		
		local event = "CHAT_MSG_SPELL_TRADESKILLS"
		PL:RegisterEvent("KOTJ", event, function(event, info) 							
							if info.type == 'feedpet' and info.victim == ParserLib_SELF then	
								KingOfTheJungle:Chat(string.format(L["%s loves %s, mjummie."],UnitName("pet"),info.item))
							end
						end)
	end
end

function KingOfTheJungle:OnDisable()    
end

function KingOfTheJungle:UPDATE_BINDINGS()
	if (not InCombatLockdown()) then
		self:OverrideBindings()		
	end
end

function KingOfTheJungle:UNIT_SPELLCAST_SUCCEEDED()
	if arg1 == "player" and arg2 == BS["Dismiss Pet"] then
		self:HideFeedPetButton()
	end	
end

function KingOfTheJungle:PLAYER_CONTROL_LOST()
	self:HideFeedPetButton()
end

function KingOfTheJungle:PLAYER_REGEN_DISABLED()
	if self.feedButton:IsShown() then
		self:HideFeedPetButton()
	end
end

function KingOfTheJungle:CHAT_MSG_SPELL_FAILED_LOCALPLAYER()
	if (arg1 and string.find(arg1, L["You fail to perform Feed Pet: You are mounted."])) then
		KingOfTheJungle:Chat(string.format(L["%s thinks you should unmount before feeding him."],UnitName("pet")))
	end
	if (arg1 and string.find(arg1, L["You fail to perform Feed Pet: Out of range."])) then
		KingOfTheJungle:Chat(string.format(L["%s likes to get closer with you before getting fed."],UnitName("pet")))
	end
	if (arg1 and string.find(arg1, L["You fail to perform Feed Pet: That food's level is not high enough for your pet."])) then
		KingOfTheJungle:Chat(string.format(L["%s wants food of a more appropriate level."],UnitName("pet")))
	end
	if (arg1 and string.find(arg1, L["You fail to perform Feed Pet: Can't do that while stunned."])) then
		KingOfTheJungle:Chat(string.format(L["%s looks at you, wondering how you will feed him when you are stunned."],UnitName("pet")))
	end
end

function KingOfTheJungle:UNIT_HAPPINESS()	
	if not self.db.char.warnPetHungry then
		return
	end	

	if InCombatLockdown() then
		return 
	end
	
	if UnitHealth("pet") <= 0 or UnitIsDeadOrGhost("pet") then
		self:HideFeedPetButton()
		return
	end
	
	
--~     Number - the numerical happiness value of the pet (1 = unhappy, 2 = content, 3 = happy)
	local happiness, _, _ = GetPetHappiness()	
	
	if happiness and happiness <= self.db.char.petHappinessLevel then
		if self.db.char.warnPetHungry then
			if not self:CheckForBuffByPath(L["Feed Pet Effect"]) then
				if self:FeedPet()~=nil then
					self.feedButton:Show()
					return
				else					
					if difftime(time(), self.db.char.lastWarningTime) > self.db.char.msgInterval then
						self.db.char.lastWarningTime = time()
						KingOfTheJungle:Chat(string.format(L["%s looks in your bags and sees no food in there."],UnitName("pet")))
					end
				end
			end
		end
	end	
	
	self:HideFeedPetButton()
end

function KingOfTheJungle:Chat(text)
	DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffeda55f %s |r", tostring(text)))	
end

function KingOfTheJungle:CheckForBuffByPath(texture)
	local i = 1;	
	local _, _, buffTexture, _ = UnitBuff("pet",i)	
	while buffTexture do
		if string.find(texture, buffTexture) then
			return true
		end
		i = i + 1
		_, _, buffTexture, _ = UnitBuff("pet",i)
	end
	return false
end

function KingOfTheJungle:FeedPet()	
	local diets = {GetPetFoodTypes()}
	
	for i,_ in ipairs(self.db.profile.foodlist) do
		if self.db.profile.foodlist[i]["selected"] then
		
			for idx, _ in ipairs(diets) do
				local tmp_diet = L:GetReverseTranslation(diets[idx])
				if (L[tmp_diet] == L["Raw Meat"])  then	
					tmp_diet = L:GetReverseTranslation("Food - Meat Raw")
				end
				if (L[tmp_diet] == L["Raw Fish"]) then
					tmp_diet = L:GetReverseTranslation("Food - Fish Raw")
				end
				if string.find(self.db.profile.foodlist[i]["diet"],tmp_diet) then 
					for index,_ in pairs(self.db.profile.foodlist[i]["list"]) do
						itemName, itemLink, _, itemLevel, _, _, _, _, _, _ = GetItemInfo(self.db.profile.foodlist[i]["list"][index]["id"])
						if itemLink and GetItemCount(itemLink) > 0 and self.db.profile.foodlist[i]["list"][index]["selected"] then			
							self.feedButton:SetAttribute("target-item", itemName)
							return itemLink
						end
					end
				end
			end
		end
	end	
	self.feedButton:SetAttribute("target-item", ATTRIBUTE_NOOP)
	return nil
end

function KingOfTheJungle:HideFeedPetButton()
	if not (GetPetHappiness() == 3 and self.db.char.petHappinessLevel == 3) then
		self.feedButton:Hide()
	end
end