local L = AceLibrary("AceLocale-2.2"):new("KingOfTheJungle")

function KingOfTheJungle:KOTJUI_CreateOptions(parent, width, height)  	
--~ 	FRAMES
	local f = CreateFrame("Frame",nil,parent)
	local cb1 = CreateFrame("CheckButton",nil,f,"UICheckButtonTemplate")	
	local editbox = CreateFrame("EditBox",nil,f,"InputBoxTemplate")
	local slider = CreateFrame("Slider","KOTJOptionsSliderHappiness",f,"OptionsSliderTemplate")
	
	f:SetPoint("TOPLEFT",0) 
	f:SetWidth(width) 
	f:SetHeight(height)
	
	cb1:SetPoint("TOPLEFT", f,"TOPLEFT",28,-80)	
	
	cb1:SetChecked(KingOfTheJungle.db.char.warnPetHungry)
	
	cb1:SetScript("OnEnter", function()
		GameTooltip:SetOwner(this, cb1)
		GameTooltip:SetText(L["Show feed pet button when pet is hungry."])
		GameTooltip:Show()		
	end)	
	
	cb1:SetScript("OnLeave", function()
		GameTooltip:Hide()	
	end)	
	
	cb1:SetScript("OnClick", function()
		KingOfTheJungle.db.char.warnPetHungry = cb1:GetChecked()		
	end)
	
	cb1.Text1 = cb1:CreateFontString(nil, "ARTWORK", "GameFontNormal")	
	cb1.Text1:SetText(L["Feed Button"])
	cb1.Text1:SetJustifyH("LEFT")
	cb1.Text1:SetPoint("RIGHT", cb1, "RIGHT", cb1.Text1:GetStringWidth(), 0)	
	
	editbox.Text1 = editbox:CreateFontString(nil, "ARTWORK", "GameFontNormal")		
	editbox.Text1:SetText(L["Warning Interval"])
	editbox.Text1:SetJustifyH("LEFT")
	editbox.Text1:SetPoint("TOPLEFT", f, "TOPLEFT", 28, -120)
	
	editbox:SetPoint("RIGHT", editbox.Text1,"RIGHT", editbox.Text1:GetStringWidth(),0)	
	editbox:SetWidth(50)
    editbox:SetHeight(20)
    editbox:SetNumeric(true)
	editbox:SetText(KingOfTheJungle.db.char.msgInterval)
	
	editbox:SetScript("OnEnterPressed", function()
		if  tonumber(editbox:GetText()) then
			KingOfTheJungle.db.char.msgInterval = tonumber(editbox:GetText())
		else
			KingOfTheJungle.db.char.msgInterval = 0
			editbox:SetText(0)
		end			
	end)
	
	editbox:SetScript("OnEnter", function()
		GameTooltip:SetOwner(this, cb1)
		GameTooltip:SetText(L["Sets interval in seconds at which warnings occur."])
		GameTooltip:Show()		
	end)
	
	editbox:SetScript("OnLeave", function()
		GameTooltip:Hide()	
	end)
	
	slider:SetPoint("TOPLEFT", f, "TOPLEFT", 28, -160)
	slider:SetMinMaxValues(1,3)
	slider:SetValue(self.db.char.petHappinessLevel)
	slider:SetValueStep(1)
	
	slider.tooltipText = L["Show Feed Button at Happiness Level"] 
	KOTJOptionsSliderHappinessLow:SetText(L["Unhappy"])
	KOTJOptionsSliderHappinessHigh:SetText(L["Happy"])
	
	local hap = {L["Unhappy"],L["Content"],L["Happy"]}
	KOTJOptionsSliderHappinessText:SetText(hap[slider:GetValue()])
	
	slider:SetScript("OnValueChanged", function()
		local hap = {L["Unhappy"],L["Content"],L["Happy"]}
		KOTJOptionsSliderHappinessText:SetText(hap[slider:GetValue()])	
		self.db.char.petHappinessLevel = slider:GetValue()
	end)
	
	return f
end